from hbmqtt.plugins.authentication import BaseAuthPlugin
from passlib.hash import pbkdf2_sha256

class AlfonsHBMQTTAuthPlugin(BaseAuthPlugin):
	def __init__(self, context):
		super().__init__(context)
		
		self.alfonsDb = self.auth_config["alfons-db"]

	async def authenticate(self, *args, **kwargs):
		session = kwargs.get("session", None)

		username = session.username
		password = session.password
		
		with self.alfonsDb as db:
			fetch = db.cursor.execute("SELECT password FROM users WHERE username = ?", [username]).fetchone()

			if fetch != None and len(fetch) == 1:
				if pbkdf2_sha256.verify(password, fetch[0]):
					return True

		return False

